=== tests/spec/glsl-1.50/CMakeLists.txt ===
add_subdirectory (execution)
piglit_include_target_api()
