=== tests/spec/arb_gpu_shader5/compiler/CMakeLists.txt ===
add_subdirectory (stream-qualifier)
piglit_include_target_api()
