## piglit 0~git20231002-24207f5be

=== debian/changelog ===
piglit (0~git20231002-24207f5be-1) unstable; urgency=medium

  * Update piglit upstream version to 24207f5be

 -- Jordan Justen <jljusten@debian.org>  Fri, 06 Oct 2023 11:12:56 -0700

piglit (0~git20230729-191c8b687-1) unstable; urgency=medium

  * Update piglit upstream version to 191c8b687
  * debian: Add update-git-release.sh script to help automate new releases
  * d/patches: Drop patches after upstream 191c8b687620

 -- Jordan Justen <jljusten@debian.org>  Mon, 07 Aug 2023 02:08:48 -0700

piglit (0~git20230613-172030ccb-1) unstable; urgency=medium

  * Update piglit upstream version to 172030ccb
  * d/control: Update Standards-Version to 4.6.2
  * d/control: Fix build-depends-on-obsolete-package (libgl1-mesa-dev => libgl-dev)
  * d/piglit.lintian-overrides: Update override format
  * d/copyright: Update location of glsl-gnome-shell-dim-window.shader_test

 -- Jordan Justen <jljusten@debian.org>  Mon, 31 Jul 2023 23:16:07 -0700
