=== debian/control ===
Source: piglit
Priority: optional
Section: devel
Maintainer: Jordan Justen <jljusten@debian.org>
Build-Depends: bash-completion,
               binutils (>> 2.18),
               cmake,
               debhelper-compat (= 13),
               dh-python,
               glslang-tools,
               libegl1-mesa-dev | libegl-dev,
               libgbm-dev,
               libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libvulkan-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               ocl-icd-opencl-dev | opencl-dev,
               libwaffle-dev (>= 1.3),
               ninja-build,
               pkg-config,
               python3,
               python3-mako,
               python3-numpy,
               python3-six
Standards-Version: 4.6.2
Homepage: http://piglit.freedesktop.org/
Vcs-Git: https://salsa.debian.org/xorg-team/app/piglit.git
Vcs-Browser: https://salsa.debian.org/xorg-team/app/piglit

Package: piglit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         ${python3:Depends}, python3-six, python3-mako
Recommends: waffle-utils
Description: Open-source test suite for OpenGL and OpenCL implementations
 Piglit is an open-source test suite for OpenGL and OpenCL implementations.
